/////  Christoph Schrall  (C)2011 /////////
function get_zoom_factor(img_width, img_height){

	if (img_height==0 || img_width==0 )
	  return 1;
	  
	var height_factor = client_height /  img_height;
    var width_factor = client_width / img_width;
             
    if (height_factor > width_factor)
		return Math.min(1.0,width_factor);
		
	return Math.min(1.0,height_factor);
}

function get_left_margin(img_width, zoom_factor_par) {
	return (client_width - img_width*zoom_factor_par)/2;
}
        
function get_top_margin(img_height, zoom_factor_par) {
	return (client_height - img_height*zoom_factor_par)/2;
}


function load_and_resize_image(img_id, containing_div_id, div_to_hide_id, img_path, actionpoints, comment){

    var success = false;
	  $("#"+containing_div_id).width(10000);
		$("#"+containing_div_id).height(10000);
     $("#"+img_id).css("width", "");
     $("#"+img_id).css("height", "");

		$("#"+img_id).load(function () {         
			$('#'+div_to_hide_id).hide();
			$('#'+containing_div_id).show();

			var zoom_factor =  get_zoom_factor($("#"+img_id).width(), $("#"+img_id).height());
			var w = $("#"+img_id).width() * zoom_factor;
			var h = $("#"+img_id).height() * zoom_factor;

			// Step 5: fit into screen
			$("#"+containing_div_id).height(h);
			$("#"+containing_div_id).width(w);
			$("#"+containing_div_id).css("top", get_top_margin($("#"+img_id).height(),zoom_factor)+"px");
			$("#"+containing_div_id).css("left", get_left_margin($("#"+img_id).width(),zoom_factor)+"px");
							
			$("#"+img_id).width(w);
			$("#"+img_id).height(h);
			$(this).fadeIn("slow", function() {
      			paint_action_points(actionpoints,zoom_factor*map_scale);


													});
      success = true;
	  
	  if (comment!=undefined&&comment!=null)
		set_document_title(comment);
	  else
        set_document_title(img_path);
      
        }).error(function () {
          if (!success)
            alert ( subdir+img_path + "  could not be loaded ");
        }).attr('src', subdir+img_path );
}



function paint_action_points(actionpoints,zoom_factor) {
	if ( actionpoints==null)
		return ;
	
	for(var i in actionpoints) {
	
		  actionpoints[i].paint( "map_div", zoom_factor );
		  
		  if (actionpoints.length==parseInt(i)+1)// bug in IE
  		  break;
	}
	
	addDebugLine("Map: " + map);
	addDebugLine("Subdir: " + subdir);
	addDebugLine("ClientWidth: " + client_width + "  " + client_height );
	addDebugLine("Zoom_factor: " + Math.round(zoom_factor*100)+"%");
	addDebugLine("Scale_factor: " + Math.round(map_scale*100)+"%");
	addDebugLine("Num of actionpts: " + actionpoints.length );
	
	if (actionpoints.length>0)
	   addDebugLine("Actionpoint0: " + actionpoints[0].x + "  " + + actionpoints[0].y );
  
 	show_debug_output(true,actionpoints);
	
    // Step 7: add click functionality	
	add_click_actions(actionpoints, zoom_factor );
}

function add_click_actions(actionpoints, zoom_factor ){

	var l_offset = get_left_margin($("#map_img").width(),1); 	
	var t_offset = get_top_margin($("#map_img").height(),1); 	
			
	$('#map_div').click(function(e) {
	
	// alert("check_click")
		for(var j in actionpoints) {
		
			if ( actionpoints[j].is_clicked( zoom_factor, e.pageX-l_offset, e.pageY-t_offset ) ){
						
				load_and_resize_image("zoom_img", "zoom_div", "map_div", actionpoints[j].image_file, null,actionpoints[j].comment);
				break;
			}
			
		  if (actionpoints.length==parseInt(j)+1)// bug in IE
  		  break;
			}
		});	
}

